<?php
/**
 * Defining package.
 *
 *  @package : addify_quick_order_table
 */

if ( ! defined( 'ABSPATH' ) ) {
		exit;
}

/**
 * Creating Class.
 */
class Addify_Qof_Ajax_Controller {

	/**
	 * Constructor.
	 */
	public function __construct() {

		add_action( 'wp_ajax_addify_search_products', array( $this, 'addify_search_products' ) );

		add_action( 'wp_ajax_addify_add_to_cart', array( $this, 'add_to_cart' ) );
		add_action( 'wp_ajax_nopriv_addify_add_to_cart', array( $this, 'add_to_cart' ) );

		add_action( 'wp_ajax_addify_bulk_add_to_cart', array( $this, 'addify_bulk_add_to_cart' ) );
		add_action( 'wp_ajax_nopriv_addify_bulk_add_to_cart', array( $this, 'addify_bulk_add_to_cart' ) );

		add_action( 'wp_ajax_addify_search_customer', array( $this, 'addify_search_customer' ) );

		add_action( 'wp_ajax_qof_front_product_search_fun', array( $this, 'qof_front_product_search_fun' ) );
		add_action( 'wp_ajax_nopriv_qof_front_product_search_fun', array( $this, 'qof_front_product_search_fun' ) );

		add_action( 'wp_ajax_qof_front_sku_search_fun', array( $this, 'qof_front_sku_search_fun' ) );
		add_action( 'wp_ajax_nopriv_qof_front_sku_search_fun', array( $this, 'qof_front_sku_search_fun' ) );

		add_action( 'wp_ajax_qof_front_category_search_fun', array( $this, 'qof_front_category_search_fun' ) );
		add_action( 'wp_ajax_nopriv_qof_front_category_search_fun', array( $this, 'qof_front_category_search_fun' ) );

		add_action( 'wp_ajax_qof_front_tag_search_fun', array( $this, 'qof_front_tag_search_fun' ) );
		add_action( 'wp_ajax_nopriv_qof_front_tag_search_fun', array( $this, 'qof_front_tag_search_fun' ) );

		add_action( 'wp_ajax_qof_filter_update_table', array( $this, 'qof_filter_update_table' ) );
		add_action( 'wp_ajax_nopriv_qof_filter_update_table', array( $this, 'qof_filter_update_table' ) );

		add_action( 'wp_ajax_qof_search_update_table', array( $this, 'qof_search_update_table' ) );
		add_action( 'wp_ajax_nopriv_qof_search_update_table', array( $this, 'qof_search_update_table' ) );
			
		add_action( 'wp_ajax_qof_search_update_table_pagination', array( $this, 'qof_search_update_table_pagination' ) );

		add_action( 'wp_ajax_nopriv_qof_search_update_table_pagination', array( $this, 'qof_search_update_table_pagination' ) );
	}

	/**
	 * Creating qof_filter_update_table.
	 */
	public function qof_update_whole_table_data( $filter_table, $search_table ) {
		
		if ( isset( $_POST['qof_security_nonce_action'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['qof_security_nonce_action'], 'qof_security_fields_nonce' ) ) ) ) {
			print 'Sorry, your nonce did not verify.';
			exit;
		}
		if (isset($_POST['filter_data'])) {

			parse_str(sanitize_meta( '', $_POST['filter_data'], '' ), $filter_data  );
			$active_rule_id = $filter_data['rule_id'];
		}
		if (isset($_POST['search_data'])) {
			parse_str(sanitize_meta( '', $_POST['search_data'], '' ), $search_data  );
			$active_rule_id = $search_data['rule_id'];
		}
		
		$qof_enable_pagination = get_post_meta( $active_rule_id, 'qof_pagiantion', true );
		$qof_pagination_value  = get_post_meta( $active_rule_id, 'qof_enable_pagination', true );
		if ( 'yes' === $qof_enable_pagination ) {
			$posts_per_page = -1;
		} else {
			$posts_per_page = $qof_pagination_value;
		}

		if (!empty($search_table)  ) {
			if ( isset( $search_table['qof_front_product_select'] ) ) {

				$qof_search_spec_product = sanitize_meta( '', wp_unslash( $search_table['qof_front_product_select'] ), '' );

			} else {
				$qof_search_spec_product = '';
			}
			if ( isset( $search_table['qof_front_sku_select'] ) ) {

				$qof_search_spec_sku = sanitize_meta( '', wp_unslash( $search_table['qof_front_sku_select'] ), '' );
			} else {
				$qof_search_spec_sku = '';
			}
				
			$qof_search_spec_product = array_unique( array_merge( (array) $qof_search_spec_product, (array) $qof_search_spec_sku ) );

			$args                     = array(
				'post_type'      => 'product',
				'orderby'        => 'title',
				'order'          => 'ASC',
				'posts_per_page' => $posts_per_page,
				'paged'          => 1,
				'post__in'       => $qof_search_spec_product,
			);
			$loop_product_show_update = new WP_Query( $args );

		} elseif (!empty($filter_table)  ) {

			if ( isset( $filter_table['qof_front_category_select'] ) ) {

					$qof_search_spec_category = sanitize_meta( '', wp_unslash( $filter_table['qof_front_category_select'] ), '' );

			} else {
				$qof_search_spec_category = '';
			}
			if ( isset( $filter_table['qof_front_tag_select'] ) ) {

				$qof_search_spec_tag = sanitize_meta( '', wp_unslash( $filter_table['qof_front_tag_select'] ), '' );

			} else {
				$qof_search_spec_tag = '';
			}
					$qof_simple_product = array();
			if ( ! empty( $qof_search_spec_category ) ) {
				$qof_simple_product[] = array(
					'taxonomy' => 'product_cat',
					'terms'    => $qof_search_spec_category,
					'operator' => 'IN',
				);
			}
			if ( ! empty( $qof_search_spec_tag ) ) {
				$qof_simple_product[]           = array(
					'taxonomy' => 'product_tag',
					'terms'    => $qof_search_spec_tag,
					'operator' => 'IN',
				);
				$qof_simple_product['relation'] = 'OR';
			}
			$args                     = array(
				'post_type'      => 'product',
				'orderby'        => 'title',
				'order'          => 'ASC',
				'posts_per_page' => $posts_per_page,
				'paged'          => 1,
				'tax_query'      => $qof_simple_product,
			);
			$loop_product_show_update = new WP_Query( $args );
				
		} 
			
		return $loop_product_show_update;
	}

	/**
	 * Creating qof_search_update_table_pagination.
	 */
	public function qof_search_update_table_pagination() {
		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : 0;
		if ( isset( $_POST['q'] ) && '' !== $_POST['q'] ) {
			if ( ! wp_verify_nonce( $nonce, 'quick_order_nonce' ) ) {
				die( 'Failed ajax security check!' );
			}
			$pro = sanitize_text_field( wp_unslash( $_POST['q'] ) );
		} else {
			$pro = '';
		}

		if (isset($_POST['search_data'])) {

			parse_str(sanitize_meta( '', $_POST['search_data'], '' ), $search_data  );
			

		}//print_r($_POST['search_data']);
		if (isset( $_POST['paged']) ) {
			$paged = sanitize_text_field( wp_unslash($_POST['paged'] ) );
		}

		$search_data_table = sanitize_meta( '', wp_unslash( $search_data ), '' );
		//print_r($search_data_table);
		$active_rule_id        = $search_data_table['rule_id'];
		$qof_enable_pagination = get_post_meta( $active_rule_id, 'qof_pagiantion', true );
		$qof_pagination_value  = get_post_meta( $active_rule_id, 'qof_enable_pagination', true );


		if ( 'yes' === $qof_enable_pagination ) {
			$posts_per_page = -1;
		} else {
			$posts_per_page = $qof_pagination_value;
		}

		if (!empty($search_data_table)) {//die('search data');
			
			$qof_all_product = get_post_meta( $active_rule_id, 'qof_all_pro', true );

			if ( 'yes' === $qof_all_product ) { // "sd1";//die('all pro');

				$args                     = array(
					'post_type'      => 'product',
					'orderby'        => 'title',
					'order'          => 'ASC',
					'posts_per_page' => $posts_per_page,
					'paged'          => $paged,
					'fields'         => 'ids',
				);
				$loop_product_show_update = new WP_Query( $args );

				//if ( isset( $search_data_table['qof_front_product_select'] ) ) {

				$qof_search_spec_product = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_product_select'] ), '' );

				//}  
				//if ( isset( $search_data_table['qof_front_sku_select'] ) ) {

				$qof_search_spec_sku = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_sku_select'] ), '' );
				//} 
				$qof_search_spec_product = array_unique( array_merge( (array) $qof_search_spec_product, (array) $qof_search_spec_sku ) );

				if (! empty( $qof_search_spec_product )) {
					$args                     = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => $posts_per_page,
						'paged'          => $paged,
						'post__in'       => $qof_search_spec_product,
					);
					$loop_product_show_update = new WP_Query( $args );
				}

				//if ( isset( $search_data_table['qof_front_category_select'] ) ) {

						$qof_search_spec_category = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_category_select'] ), '' );

				//}
				//if ( isset( $search_data_table['qof_front_tag_select'] ) ) {

						$qof_search_spec_tag = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_tag_select'] ), '' );

				//}

				$qof_simple_product = array();
				if ( ! empty( $qof_search_spec_category ) ) { //echo "sd2";//die('search data cat');
					$qof_simple_product[] = array(
						'taxonomy' => 'product_cat',
						'terms'    => $qof_search_spec_category,
						'operator' => 'IN',
					);
				}
				if ( ! empty( $qof_search_spec_tag ) ) {//echo "sd3";//die('search data');
					$qof_simple_product[]           = array(
						'taxonomy' => 'product_tag',
						'terms'    => $qof_search_spec_tag,
						'operator' => 'IN',
					);
					$qof_simple_product['relation'] = 'OR';
				}
				if ( ! empty( $qof_search_spec_category ) || ! empty( $qof_search_spec_tag ) ) {//echo "sd4";//die('search data');

					$args                 = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => -1,
						'tax_query'      => $qof_simple_product,
						'fields'         => 'ids',
					);
					$loop_product_tag_cat = new WP_Query( $args );
					$qof_products         = $loop_product_tag_cat->get_posts();

					$qof_search_get_all = array_unique( array_merge( (array) $qof_products, (array) $qof_search_spec_product ) );

				} else { //echo "sd5";

					$qof_search_get_all = $qof_search_spec_product;
					//print_r($qof_search_get_all);
				}

					$args                     = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => $posts_per_page,
						'paged'          => $paged,
						'post__in'       => $qof_search_get_all,
					);
					$loop_product_show_update = new WP_Query( $args );  
				 
			} else { 

				if ( isset( $_POST['rule_id'] ) ) {
					$qof_product_rule_id = sanitize_text_field( wp_unslash( $_POST['rule_id'] ) );

				}
				if ( isset( $search_data_table['qof_front_product_select'] ) ) {

					$qof_search_spec_product = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_product_select'] ), '' );

				} else {
					$qof_search_spec_product = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_product', true ) );
				}
				if ( isset( $search_data_table['qof_front_sku_select'] ) ) {

					$qof_search_spec_sku = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_sku_select'] ), '' );
				} else {
					$qof_search_spec_sku = '';
				}
				$qof_search_spec_product = array_unique( array_merge( (array) $qof_search_spec_product, (array) $qof_search_spec_sku ) );

				if (! empty( $qof_search_spec_product )) {
					$args                     = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => $posts_per_page,
						'paged'          => $paged,
						'post__in'       => $qof_search_spec_product,
					);
					$loop_product_show_update = new WP_Query( $args );
				}

				if ( isset( $search_data_table['qof_front_category_select'] ) ) {

					$qof_search_spec_category = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_category_select'] ), '' );

				} else {
					$qof_search_spec_category = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_category', true ) );
						
				}
				if ( isset( $search_data_table['qof_front_tag_select'] ) ) {

					//print_r($search_data_table['qof_front_tag_select']);

					$qof_search_spec_tag = sanitize_meta( '', wp_unslash( $search_data_table['qof_front_tag_select'] ), '' );

				} else {
					$qof_search_spec_tag = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_tag', true ) );
				}
					$qof_simple_product = array();
				if ( ! empty( $qof_search_spec_category ) ) { //echo "sd2";//die('search data cat');
					$qof_simple_product[] = array(
						'taxonomy' => 'product_cat',
						'terms'    => $qof_search_spec_category,
						'operator' => 'IN',
					);
				}
				if ( ! empty( $qof_search_spec_tag ) ) {//echo "sd3";//die('search data');
					$qof_simple_product[]           = array(
						'taxonomy' => 'product_tag',
						'terms'    => $qof_search_spec_tag,
						'operator' => 'IN',
					);
					$qof_simple_product['relation'] = 'OR';
				}
				if ( ! empty( $qof_search_spec_category ) || ! empty( $qof_search_spec_tag ) ) {//echo "sd4";//die('search data');

					$args                 = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => -1,
						'tax_query'      => $qof_simple_product,
						'fields'         => 'ids',
					);
					$loop_product_tag_cat = new WP_Query( $args );
					$qof_products         = $loop_product_tag_cat->get_posts();

					$qof_search_get_all = array_unique( array_merge( (array) $qof_products, (array) $qof_search_spec_product ) );

				} else { //echo "sd5";

					$qof_search_get_all = $qof_search_spec_product;
					//print_r($qof_search_get_all);
				}

					$args                     = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => $posts_per_page,
						'paged'          => $paged,
						'post__in'       => $qof_search_get_all,
					);
					$loop_product_show_update = new WP_Query( $args );

			}   

		}
		 
		$loop_product_show = $loop_product_show_update;
		//print_r($loop_product_show);exit();
		ob_start();
		include QOF_PLUGIN_DIR . 'class-addify-qof-update-table.php';
		$qof_filter_update_table = ob_get_clean();
		ob_start();
		if ( 'yes' !== $qof_enable_pagination ) {
			?><li class="qof_replace_pagination qof_bottom_align">
			<?php
			echo wp_kses_post(
				paginate_links(
					array(
						'current' =>  $paged,
						'total'   => $loop_product_show_update->max_num_pages,
					)
				)
				);
			?>
			</li>
			<?php
		}
		$qof_filter_pagination = ob_get_clean();
		ob_start();
		$qof_total_products = $loop_product_show_update->found_posts;
		?>
		<li class="qof_product_show qof_bottom_align">
		<span class="qof_no_products">
		<?php
		esc_html_e(esc_attr( $qof_total_products ) , 'qof_form_order');
		esc_html_e('Products' , 'qof_form_order'); 
		?>
		</span>
		</li> 
		<?php
		$qof_update_product = ob_get_clean();

		ob_start();
		wp_enqueue_script( 'wc-add-to-cart-variation' );
		$script = ob_get_clean();
		wp_send_json(
			array(
				'qof-filter-detail-table' => $qof_filter_update_table,
				'qof-filter-pagination'   => $qof_filter_pagination,
				'qof_update_product'      => $qof_update_product,
				'script'                  => $script,
			)
		);

		die();
	}
	/**
	 * Creating qof_filter_update_table.
	 */
	public function qof_filter_update_table() {

		
		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : 0;
		if ( isset( $_POST['q'] ) && '' !== $_POST['q'] ) {
			if ( ! wp_verify_nonce( $nonce, 'quick_order_nonce' ) ) {
				die( 'Failed ajax security check!' );
			}
			$pro = sanitize_text_field( wp_unslash( $_POST['q'] ) );
		} else {
			$pro = '';
		}

		if (isset($_POST['filter_data'])) {

			parse_str(sanitize_meta( '', $_POST['filter_data'], '' ), $filter_data  );
		}
		$active_rule_id        = $filter_data['rule_id'];
		$qof_enable_pagination = get_post_meta( $active_rule_id, 'qof_pagiantion', true );
		$filter_table          = sanitize_meta( '', wp_unslash( $filter_data ), '' );
		$loop_product_show     = $this->qof_update_whole_table_data( $filter_table, '' );
		ob_start();
		include QOF_PLUGIN_DIR . 'class-addify-qof-update-table.php';
		$qof_filter_update_table = ob_get_clean();
		ob_start();
		if ( 'yes' !== $qof_enable_pagination ) {
			?>
			<li class="qof_replace_pagination qof_bottom_align">
			<?php
			echo wp_kses_post(
				paginate_links(
					array(
						'current' =>  1,
						'total'   => $loop_product_show->max_num_pages,
					)
				)
																	);
			?>
			</li>
			<?php
		}
		$qof_filter_pagination = ob_get_clean();
		ob_start();
		$qof_total_products = $loop_product_show->found_posts;
		?>
		<li class="qof_product_show qof_bottom_align">
		<span class="qof_no_products">
		<?php
		esc_html_e(esc_attr( $qof_total_products ) , 'qof_form_order');
		esc_html_e('Products' , 'qof_form_order'); 
		?>
		</span>
		</li> 
		<?php
		$qof_update_product = ob_get_clean();
		
		wp_send_json(
			array(
				'qof-filter-detail-table' => $qof_filter_update_table,
				'qof-filter-pagination'   => $qof_filter_pagination,
				'qof_update_product'      => $qof_update_product,
			)
		);

		die();
	}

		/**
	 * Creating qof_filter_update_table.
	 */
	public function qof_search_update_table() {

		
		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : 0;
		if ( isset( $_POST['q'] ) && '' !== $_POST['q'] ) {
			if ( ! wp_verify_nonce( $nonce, 'quick_order_nonce' ) ) {
				die( 'Failed ajax security check!' );
			}
			$pro = sanitize_text_field( wp_unslash( $_POST['q'] ) );
		} else {
			$pro = '';
		}
		if (isset($_POST['search_data'])) {
			parse_str(sanitize_meta( '', $_POST['search_data'], '' ), $search_data  );
		}
		
		$search_table          = sanitize_meta( '', wp_unslash( $search_data ), '' );
		$active_rule_id        = $search_data['rule_id'];
		$qof_enable_pagination = get_post_meta( $active_rule_id, 'qof_pagiantion', true );
		$qof_pagination_value  = get_post_meta( $active_rule_id, 'qof_enable_pagination', true );
		$loop_product_show     = $this->qof_update_whole_table_data( '' , $search_table );
		
		ob_start();
		include QOF_PLUGIN_DIR . 'class-addify-qof-update-table.php';
		$qof_search_update_table = ob_get_clean();

		ob_start();
		if ( 'yes' !== $qof_enable_pagination ) {
			?>
			<li class="qof_replace_pagination qof_bottom_align">
			<?php
			echo wp_kses_post(
				paginate_links(
					array(
						'current' =>  1,
						'total'   => $loop_product_show->max_num_pages,
					)
				)
																	);
			?>
			</li>
			<?php
		}
		$qof_search_pagination = ob_get_clean();

		ob_start();
		$qof_total_products = $loop_product_show->found_posts;
		?>
		<li class="qof_product_show qof_bottom_align">
		<span class="qof_no_products">
		<?php
		esc_html_e(esc_attr( $qof_total_products ) , 'qof_form_order');
		esc_html_e('Products' , 'qof_form_order'); 
		?>
		</span>
		</li> 
		<?php
		$qof_update_product = ob_get_clean();
		
		wp_send_json(
			array(
				'qof-search-detail-table' => $qof_search_update_table,
				'qof-search-pagination'   => $qof_search_pagination,
				'qof_update_product'      => $qof_update_product,
			)
		);

		die();
	}
	/**
	 * Creating qof_front_product_search_fun.
	 */
	public function qof_front_product_search_fun() {

		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : 0;
		if ( isset( $_POST['q'] ) && '' !== $_POST['q'] ) {
			if ( ! wp_verify_nonce( $nonce, 'quick_order_nonce' ) ) {
				die( 'Failed ajax security check!' );
			}
			$pro = sanitize_text_field( wp_unslash( $_POST['q'] ) );
		} else {
			$pro = '';
		}
		if ( isset( $_POST['rule_id'] ) ) {
			$qof_product_rule_id = sanitize_text_field( wp_unslash( $_POST['rule_id'] ) );
		}

		$qof_all_product = get_post_meta( $qof_product_rule_id, 'qof_all_pro', true );
		if ( 'yes' === $qof_all_product ) {
			$data_array = array();
			$args       = array(
				'post_type'   => array( 'product' ),
				'post_status' => 'publish',
				'numberposts' => -1,
				's'           => $pro,
			);
			$pros       = get_posts( $args );
			if ( ! empty( $pros ) ) {
				foreach ( $pros as $proo ) {
					$pro_front_post = ( mb_strlen( $proo->post_title ) > 50 ) ? mb_substr( $proo->post_title, 0, 49 ) . '...' : $proo->post_title;
					$data_array[]   = array( $proo->ID, $pro_front_post ); // array( Post ID, Post Title ).
				}
			}
			echo wp_json_encode( $data_array );
			die();
		} else {
			$qof_search_spec_product = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_product', true ) );

			$qof_search_spec_category = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_category', true ) );

			$qof_search_spec_tag = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_tag', true ) );
			$qof_simple_product  = array();
			if ( ! empty( $qof_search_spec_category ) ) {
				$qof_simple_product[] = array(
					'taxonomy' => 'product_cat',
					'terms'    => $qof_search_spec_category,
					'operator' => 'IN',
				);
			}
			if ( ! empty( $qof_search_spec_tag ) ) {
				$qof_simple_product[]           = array(
					'taxonomy' => 'product_tag',
					'terms'    => $qof_search_spec_tag,
					'operator' => 'IN',
				);
				$qof_simple_product['relation'] = 'OR';
			}
			 
			if ( ! empty( $qof_search_spec_category ) || ! empty( $qof_search_spec_tag )) {
				  
				$args = array(
					'post_type' => 'product',
					'orderby'   => 'title',
					'order'     => 'ASC',
					'tax_query' => $qof_simple_product,
					'fields'    => 'ids',
				);

				$loop_product_tag_cat = new WP_Query( $args );
				$qof_products         = $loop_product_tag_cat->get_posts();
			}


			$qof_search_get_all = array_unique( array_merge( (array) $qof_products, (array) $qof_search_spec_product ) );
			 
			$data_array        = array();
			$args              = array(
				'post_type' => 'product',
				'post__in'  => $qof_search_get_all,
				's'         => $pro,
			);
			$loop_product_show = new WP_Query( $args );
			$product_data      = $loop_product_show->get_posts();
			foreach ( $product_data as $product_data_show ) {
				if ( is_object( $product_data_show ) ) {
						$product_data_show = get_object_vars( $product_data_show );
				}
					$values                 = $product_data_show['ID'];
					$addify_sec_product_ids = $values;
					$product                = wc_get_product( $addify_sec_product_ids );

					$addify_wl_pro_title = $product->get_title();
					$data_array[]        = array( $addify_sec_product_ids, $addify_wl_pro_title );

			}
			echo wp_json_encode( $data_array );
			die();
		}
	}
	/**
	 * Creating qof_front_sku_search_fun.
	 */
	public function qof_front_sku_search_fun() {
		global $post;
		$nonce = isset( $_POST['nonce'] ) && '' !== $_POST['nonce'] ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : 0;
		if ( isset( $_POST['q'] ) && '' !== $_POST['q'] ) {
			if ( ! wp_verify_nonce( $nonce, 'quick_order_nonce' ) ) {
				die( 'Failed ajax security check!' );
			}
			$pro = sanitize_text_field( wp_unslash( $_POST['q'] ) );
		} else {
			$pro = '';
		}

		if ( isset( $_POST['rule_id'] ) ) {
			$qof_product_rule_id = sanitize_text_field( wp_unslash( $_POST['rule_id'] ) );
		}

		$qof_all_product = get_post_meta( $qof_product_rule_id, 'qof_all_pro', true );

		if ( 'yes' === $qof_all_product ) {
			$data_array = array();
			$args       = array(
				'post_type'   => array( 'product' ),
				'post_status' => 'publish',
				'numberposts' => -1,
				'meta_query'  => array(
					array(
						'key'     => '_sku',
						'value'   => $pro,
						'compare' => 'like',
					),
				),
			);
			$pros       = get_posts( $args );
			if ( ! empty( $pros ) ) {
				foreach ( $pros as $proo ) {
					$product   = wc_get_product( $proo->ID );
					$check_sku = $product->get_sku();
					if ( ! empty( $check_sku ) ) {
						$pro_front_post = ( mb_strlen( $product->get_sku() ) > 50 ) ? mb_substr( $product->get_sku(), 0, 49 ) . '...' : $product->get_sku();
						$data_array[]   = array( $proo->ID, $pro_front_post ); // array( Post ID, Post Title ).
					}
				}
			}
			echo wp_json_encode( $data_array );
			die();

		} else {

			$qof_search_spec_product = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_product', true ) );

			$qof_search_spec_category = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_category', true ) );

			$qof_search_spec_tag = json_decode( get_post_meta( $qof_product_rule_id, 'qof_search_tag', true ) );
			$qof_simple_product  = array();
			if ( ! empty( $qof_search_spec_category ) ) {
				$qof_simple_product[] = array(
					'taxonomy' => 'product_cat',
					'terms'    => $qof_search_spec_category,
					'operator' => 'IN',
				);
			}
			if ( ! empty( $qof_search_spec_tag ) ) {
				$qof_simple_product[]           = array(
					'taxonomy' => 'product_tag',
					'terms'    => $qof_search_spec_tag,
					'operator' => 'IN',
				);
				$qof_simple_product['relation'] = 'OR';
			}
			 
			if ( ! empty( $qof_search_spec_category ) || ! empty( $qof_search_spec_tag )) {
				  
				$args = array(
					'post_type' => 'product',
					'orderby'   => 'title',
					'order'     => 'ASC',
					'tax_query' => $qof_simple_product,
					'fields'    => 'ids',
				);

				$loop_product_tag_cat = new WP_Query( $args );
				$qof_products         = $loop_product_tag_cat->get_posts();
			}


			$qof_search_get_all = array_unique( array_merge( (array) $qof_products, (array) $qof_search_spec_product ) );
			$data_array         = array();
			$args               = array(
				'post_type'  => 'product',
				'post__in'   => $qof_search_get_all,
				'meta_query' => array(
					array(
						'key'     => '_sku',
						'value'   => $pro,
						'compare' => 'like',
					),
				),
			);
			$loop_product_show  = new WP_Query( $args );
			$product_data       = $loop_product_show->get_posts();
		 
			if ( ! empty( $product_data ) ) {
				foreach ( $product_data as $proo ) {
					$product   = wc_get_product( $proo->ID );
					$check_sku = $product->get_sku();
					if ( ! empty( $check_sku ) ) {
						$pro_front_post = ( mb_strlen( $product->get_sku() ) > 50 ) ? mb_substr( $product->get_sku(), 0, 49 ) . '...' : $product->get_sku();
						$data_array[]   = array( $proo->ID, $pro_front_post ); // array( Post ID, Post Title ).
					}
				}
			}
			echo wp_json_encode( $data_array );
			die();
		}
	}
	
	/**
	 * Creating addify_add_to_cart.
	 */
	public function addify_bulk_add_to_cart() {
		ob_start();
		if ( isset( $_POST['qof_security_nonce_action'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['qof_security_nonce_action'], 'qof_security_fields_nonce' ) ) ) ) {
			print 'Sorry, your nonce did not verify.';
			exit;
		}
		
		if (isset($_POST['form_data'])) {
			parse_str(sanitize_meta( '', $_POST['form_data'], '' ), $form_data  );
		}
		//print_r($form_data);
		
		$form_table = sanitize_meta( '', wp_unslash( $form_data ), '' );
		
		foreach ( (array) $form_table['qof_product_checkboxes'] as  $product_id ) {
				$product = wc_get_product( $product_id );
			//print_r($form_table['bulk_quantity']);
			if ( $product->is_type( 'variation' ) ) {

				if ( isset($form_table['bulk_quantity'][ $product_id ] ) ) {//print_r('elseif');
					$quantity = intval( $form_table['bulk_quantity'][ $product_id ] );
				} else {
					$quantity = 1;
				}
				
			} elseif ( isset($form_table['quantity'][ $product_id ] ) ) {
				//print_r('if');

					$quantity = intval( $form_table['quantity'][ $product_id ] );

			} else {
				$quantity = 1;
			}

			//echo $product_id . '-' . $quantity . ' | ';

			$product           = wc_get_product( $product_id );
			$passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity );
			$product_status    = get_post_status( $product_id );
			$variation_id      = 0;
			$variation         = array();
			
			if ( $product && 'variation' === $product->get_type() ) {
				$variation_id = $product_id;
				$product_id   = $product->get_parent_id();
				

				foreach ( $form_table as $key => $value ) {
					$key_explode = explode('_', $key );
					if ( 'attribute' === current($key_explode ) && isset( $value[ $variation_id ] ) ) {
						$variation[ $key ] = $value[ $variation_id ];
					}
				}
			}


			if ( $passed_validation && false !== WC()->cart->add_to_cart( $product_id, $quantity, $variation_id, $variation ) && 'publish' === $product_status ) {

				do_action( 'woocommerce_ajax_added_to_cart', $product_id );

				if ( 'yes' === get_option( 'woocommerce_cart_redirect_after_add' ) ) {
					wc_add_to_cart_message( array( $product_id => $quantity ), true );
				}
			}
		}
		
		self::get_refreshed_fragments();
	}
	/**
	 * AJAX add to cart.
	 */
	public function add_to_cart() {
		ob_start();
		if ( isset( $_POST['qof_security_nonce_action'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['qof_security_nonce_action'], 'qof_security_fields_nonce' ) ) ) ) {
			print 'Sorry, your nonce did not verify.';
			exit;
		}

		if ( isset( $_POST['data'] ) ) {

			parse_str( sanitize_meta( '', wp_unslash( $_POST['data'] ), ''), $form_data );

			$product_id   = absint( $form_data['product_id'] );
			$quantity     = empty( $form_data['quantity'] ) ? 1 :  current( $form_data['quantity'] );
			$variation_id = empty( $form_data['variation_id'] ) ? 0 : $form_data['variation_id'];
			$variation    = array();

			$product = wc_get_product( $product_id );

			foreach ($form_data as $key => $value) {
				$key_explode = explode('_', $key );

				if ( 'attribute' === current( $key_explode ) ) {
					$variation[ $key ] = current( $value );
				}
			}

		} else {
			// phpcs:disable WordPress.Security.NonceVerification.Missing.
			if ( ! isset( $_POST['product_id'] ) ) {
				return;
			}
			if ( isset( $_POST['quantity'] ) && '0' === $_POST['quantity'] ) {
				return;
			}
			$product_id   = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['product_id'] ) );
			$product      = wc_get_product( $product_id );
			$quantity     = empty( $_POST['quantity'] ) ? 1 : wc_stock_amount( sanitize_text_field( wp_unslash( $_POST['quantity'] ) ) );
			$variation_id = 0 ;
			$variation    = array();
		}
			
		$passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity );
		$product_status    = get_post_status( $product_id );
		

		if ( $passed_validation && false !== WC()->cart->add_to_cart( $product_id, $quantity, $variation_id, $variation ) && 'publish' === $product_status ) {

			do_action( 'woocommerce_ajax_added_to_cart', $product_id );

			if ( 'yes' === get_option( 'woocommerce_cart_redirect_after_add' ) ) {
				wc_add_to_cart_message( array( $product_id => $quantity ), true );
			}

			self::get_refreshed_fragments();

		} else {

			// If there was an error adding to the cart, redirect to the product page to show any errors.
			$data = array(
				'error'       => true,
				'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id ),
			);

			wp_send_json( $data );
		}
		// phpcs:enable.
	}
 

	/**
	 * Get a refreshed cart fragment, including the mini cart HTML.
	 */
	public static function get_refreshed_fragments() {
		ob_start();

		woocommerce_mini_cart();

		$mini_cart = ob_get_clean();

		$data = array(
			'fragments' => apply_filters(
				'woocommerce_add_to_cart_fragments',
				array(
					'div.widget_shopping_cart_content' => '<div class="widget_shopping_cart_content">' . $mini_cart . '</div>',
				)
			),
			'cart_hash' => WC()->cart->get_cart_hash(),
		);

		wp_send_json( $data );
	}
}

/**
* Class Object.
*/
if ( class_exists( 'Addify_Qof_Ajax_Controller' ) ) {
	$addify_qof_ajax_controller = new addify_qof_ajax_controller();
}
