<?php
/**
 * Defining package.
 *
 *  @package : addify_quick_order_form
 */

if ( ! defined( 'ABSPATH' ) ) {
		exit;
}

/**
 * Creating Class.
 */
class Addify_Qof_Frontend {

	/**
	 * Constructor.
	 */
	public function __construct() {

		add_action( 'wp_enqueue_scripts', array( $this, 'qof_frontend_enqueue_scripts' ) );
		add_shortcode( 'qof_quick_order_form', array( $this, 'qof_display_product_table' ) );
		add_action( 'wp_loaded', array( $this, 'qof_bulk_add_to_cart' ) );
	}
	/**
	 * Constructor.
	 */
	public function qof_frontend_enqueue_scripts() {

		//global $post; 

		// $active_rule_id = $attr['id'];

		wp_enqueue_style( 'qof_frontend_style', plugins_url( 'assets/css/addify_qof_frontend_style.css', __FILE__ ), false, '1.0.0' );
		wp_enqueue_script( 'qof_frontend_js', plugins_url( 'assets/js/addify_qof_front.js', __FILE__ ), array( 'jquery' ), '1.0.0', false );
		wp_enqueue_style( 'qof_front_select2_style', plugins_url( 'assets/css/select2.css', __FILE__ ), false, '1.0.0' );
		wp_enqueue_script( 'qof_front_select2_js', plugins_url( 'assets/js/select2.js', __FILE__ ), array( 'jquery' ), '1.0.0', false );
			$addify_qof_ajax_data = array(
				'admin_url' => admin_url( 'admin-ajax.php' ),
				'nonce'     => wp_create_nonce( 'quick_order_nonce' ),
				//'custom_filters'  => json_decode( get_post_meta( $post_id, '_custom_search_filters_info', true ) ),
			);
			wp_localize_script( 'qof_frontend_js', 'addify_qof_sku_var', $addify_qof_ajax_data );

			//$custom_filters = json_decode( get_post_meta( get_the_ID(), '_custom_search_filters_info', true ) );
	}
	/**
	 * Constructor.
	 */
	public function qof_bulk_add_to_cart() {
		if ( ! isset( $_POST['qof_product_checkboxes'] ) ) {
			return;
		}
		wp_nonce_field( 'qof_security_nonce_action', 'qof_security_fields_nonce' );
		if ( isset( $_POST['qof_security_nonce_action'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['qof_security_nonce_action'], 'qof_security_fields_nonce' ) ) ) ) {
			print 'Sorry, your nonce did not verify.';
			exit;
		}
		if ( isset( $_POST['qof_product_checkboxes'] ) && ! empty( $_POST['qof_product_checkboxes'] ) ) {
			$checked_product = sanitize_meta( '', wp_unslash( $_POST['qof_product_checkboxes'] ), '' );

			foreach ( $checked_product as $value ) {
				wc()->cart->add_to_cart( $value );
			}
			/* translators: %s: Products add to cart */
			wc_add_notice( sprintf( __( '%s proudtcs has been added to your cart', 'qof_form_order' ), count( $checked_product ) ) );
				wp_safe_redirect( home_url( $wp->request ) );
				exit;
		}
	}
	/**
	 * Constructor.
	 *
	 * @param int $attr First argument.
	 */
	public function qof_display_product_table( $attr ) {
		wp_nonce_field( 'qof_security_nonce_action', 'qof_security_fields_nonce' );
		if ( isset( $_POST['qof_security_nonce_action'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['qof_security_nonce_action'], 'qof_security_fields_nonce' ) ) ) ) {
			print 'Sorry, your nonce did not verify.';
			exit;
		}
		wp_enqueue_script( 'wc-add-to-cart-variation' );
		global $product;
		$active_rule_id = $attr['id'];
		$arg            = array(
			'numberposts' => -1,
			'post_type'   => 'orderform',
			'post_status' => 'publish',
			'fields'      => 'ids',
		);

			$qof_all_posts         = get_post( $arg );
			$args                  = array(
				'post_type'      => 'product',
				'post_status'    => 'publish',
				'posts_per_page' => -1,
				'fields'         => 'ids',
			);
			$products              = new WP_Query( $args );
			$qof_all_roles         = get_post_meta( $active_rule_id, 'qof_all_roles', true );
			$qof_enable_pagination = get_post_meta( $active_rule_id, 'qof_pagiantion', true );
			$qof_pagination_value  = get_post_meta( $active_rule_id, 'qof_enable_pagination', true );
			$qof_show_num          = get_post_meta( $active_rule_id, 'qof_num_products', true );
			$qof_show_quantity     = get_post_meta( $active_rule_id, 'qof_product_quantity', true );

			$addify_wl_pro_quantity = get_post_meta( $active_rule_id, 'qof_product_quantity', true );
			$filters_checking       = json_decode( get_post_meta( $active_rule_id, '_custom_search_filters_info', true ) );


			//print_r($filters_checking );
			
			// Flags of filter to show above table.
			$product_flag  = false;
			$category_flag = false;
			$tag_flag      = false;
			$sku_flag      = false;
			$empty_flag    = false;

			
			if ( '' === $filters_checking ) {

				$empty_flag = true;

			} else {

				if ( in_array( 'product_filter', (array) $filters_checking, true ) ) {
					$product_flag = true;
				}
				if ( in_array( 'category_filter', (array) $filters_checking, true ) ) {
					$category_flag = true;
				}
				if ( in_array( 'tag_filter', (array) $filters_checking, true ) ) {
					$tag_flag = true;
				}
				if ( in_array( 'sku_filter', (array) $filters_checking, true ) ) {
					$sku_flag = true;
				}
			}
			
			global $current_user;
			$user = wp_get_current_user();
			$role = (array) $user->roles;

			$flag_roles_check      = false;
			$flag_roles_spec_check = false;
			$flag_cus_user_check   = false;

			if ( 'yes' === $qof_all_roles ) {
				$flag_all_roles_check = true;
			} else {
				$qof_search_spec_roles    = json_decode( get_post_meta( $active_rule_id, 'qof_addify_roles_checkbox', true ) );
				$qof_search_spec_customer = json_decode( get_post_meta( $active_rule_id, 'qof_search_customers', true ) );
				if ( is_user_logged_in() ) {

					if ( in_array( (string) $role[0], (array) $qof_search_spec_roles, true ) ) {

						$flag_roles_spec_check = true;

					}
				} elseif ( in_array( (string) 'log_out', (array) $qof_search_spec_roles, true ) ) {

					$flag_roles_spec_check = true;

				}

				if ( in_array( (string) get_current_user_id(), (array) $qof_search_spec_customer, true ) ) {
					$flag_cus_user_check = true;
				}

				if ( ! $flag_roles_spec_check && ! $flag_cus_user_check ) {
					return;
				}
			}

			if ( 'yes' === $qof_enable_pagination ) {
				$posts_per_page = -1;
			} else {
				$posts_per_page = $qof_pagination_value;
			}
			if ( get_query_var( 'paged' ) ) {

				$paged = get_query_var( 'paged' );
			} else {
				$paged = 1;
			}
			$qof_all_product = get_post_meta( $active_rule_id, 'qof_all_pro', true );

			if ( 'yes' === $qof_all_product ) {

				$qof_search_spec_product  = '' ;
				$qof_search_spec_category = '' ;
				$qof_search_spec_category = '' ;

			} else {

				$qof_search_spec_product = json_decode( get_post_meta( $active_rule_id, 'qof_search_product', true ) );

				$qof_search_spec_category = json_decode( get_post_meta( $active_rule_id, 'qof_search_category', true ) );

				$qof_search_spec_tag = json_decode( get_post_meta( $active_rule_id, 'qof_search_tag', true ) );
			}
				$qof_simple_product = array();
			if ( ! empty( $qof_search_spec_category ) ) {
				$qof_simple_product[] = array(
					'taxonomy' => 'product_cat',
					'terms'    => $qof_search_spec_category,
					'operator' => 'IN',
				);
			}
			if ( ! empty( $qof_search_spec_tag ) ) {
				$qof_simple_product[]           = array(
					'taxonomy' => 'product_tag',
					'terms'    => $qof_search_spec_tag,
					'operator' => 'IN',
				);
				$qof_simple_product['relation'] = 'OR';
			}

					$args                 = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => -1,
						'tax_query'      => $qof_simple_product,
						'fields'         => 'ids',
					);
					$loop_product_tag_cat = new WP_Query( $args );
					$qof_products         = $loop_product_tag_cat->get_posts();
					if ( ! empty( $qof_search_spec_category ) || ! empty( $qof_search_spec_tag ) ) {

						$qof_search_get_all = array_unique( array_merge( (array) $qof_products, (array) $qof_search_spec_product ) );
					} else {
						$qof_search_get_all = $qof_search_spec_product;
					}

					$args              = array(
						'post_type'      => 'product',
						'orderby'        => 'title',
						'order'          => 'ASC',
						'posts_per_page' => $posts_per_page,
						'paged'          => $paged,
						'post__in'       => $qof_search_get_all,
						'fields'         => 'ids',
					);
					$loop_product_show = new WP_Query( $args );

					if ( ! isset( $_POST['filter'] ) && ! isset( $_POST['submit'] ) ) {
						if ( '' === $qof_all_product ) {
							if ( empty( $qof_search_spec_product ) && empty( $qof_search_spec_category ) && empty( $qof_search_spec_tag ) ) {

								echo '<h3>No products found</h3>';
								return;
							}
						}
					}
				
					?>
		<div class="qof-cart-table-section">
			<div class="qof_loader_pagination">
				<img class="qof_pic_loader" src=<?php echo esc_attr(QOF_URL) . '/assets/css/ajax-loader.gif'; ?> >
			</div>
			<form  method="POST" class="qof-above-table-form">
			<div class="qof-above-table-box">
				<input type="hidden" id="rule_id" name="rule_id" value="<?php echo esc_attr( $active_rule_id ); ?>">
				<div class="qof_search_and_filter_left">
						<?php
						if ( $category_flag ) {
							?>
					<div class="qof_top_filters_align_left">
							<?php
							if ( isset( $_POST['qof_front_category_select'] ) ) {
								$qof_print_select_category = sanitize_meta( '', wp_unslash( $_POST['qof_front_category_select'] ), '' );
							} else {
								$qof_print_select_category = array();
							}
							$qof_all_product    = get_post_meta( $active_rule_id, 'qof_all_pro', true );
							$product_categories = json_decode( get_post_meta( $active_rule_id, 'qof_search_category', true ) );
							if ( 'yes' === $qof_all_product ) {
								$orderby    = 'name';
								$order      = 'asc';
								$hide_empty = false;
								$cat_args   = array(
									'orderby' => $orderby,
									'order'   => $order,
								);

								$product_categories = get_terms( 'product_cat' );
							} 
							?>

						<select  class="qof_front_category_select" name="qof_front_category_select[]" multiple data-placeholder="<?php esc_html_e('Select Category...' , 'qof_form_order'); ?>" >
							<?php
							foreach ( $product_categories  as $product_category ) {
								if (is_int($product_category) || is_string($product_category)) {
										
									$product_category = get_term_by('id', $product_category, 'product_cat');
								}
								?>
							<option value="<?php echo esc_html( $product_category->term_id ); ?>"
									<?php
									if ( in_array( (string) $product_category->term_id, (array) $qof_print_select_category, true ) ) {
										echo 'selected'; }
									?>
							>
									<?php /* translators: %s: Customer billing full name */ ?>
									<?php echo esc_html__($product_category->name , 'qof_form_order' ); ?>
							</option>
									<?php
							}
							?>
					</select>
					</div>
							<?php
						}
						if ( $tag_flag ) {
							?>
					<div class="qof_top_filters_align_left">
							<?php
							if ( isset( $_POST['qof_front_tag_select'] ) ) {
								$qof_print_select_tag = sanitize_meta( '', wp_unslash( $_POST['qof_front_tag_select'] ), '' );
							} else {
								$qof_print_select_tag = array();
							}
							$qof_all_product = get_post_meta( $active_rule_id, 'qof_all_pro', true );
							$product_tags    = json_decode( get_post_meta( $active_rule_id, 'qof_search_tag', true ) );
							if ( 'yes' === $qof_all_product ) {
								$orderby    = 'name';
								$order      = 'asc';
								$hide_empty = false;
								$tag_args   = array(
									'orderby' => $orderby,
									'order'   => $order,
								);

								$product_tags = get_terms( 'product_tag' );
							} 
								
							?>
						<select class="qof_front_tag_select" name="qof_front_tag_select[]" multiple data-placeholder= "<?php esc_html_e('Select TAG...' , 'qof_form_order'); ?>" >
							<?php
							
							foreach ( $product_tags as $product_tag ) {
								if (is_int($product_tag ) || is_string($product_tag) ) {
										
									$product_tag = get_term_by('id', $product_tag, 'product_tag');
								}
								?>
							<option value="<?php echo esc_html( $product_tag->term_id ); ?>"
									<?php
									if ( in_array( (string) $product_tag->term_id, (array) $qof_print_select_tag, true ) ) {
										echo 'selected'; }
									?>
								>
									<?php /* translators: %s: Customer billing full name */ ?>
									<?php echo esc_html__ ($product_tag->name , 'qof_form_order' ); ?>
							</option>
									<?php
							}
							?>
					</select>
					</div>
							<?php
						}
						if ( $category_flag || $tag_flag ) {
							?>
					<div class="qof_top_filters_align_left_button">
						<input class=" qof_filter_btn qof-above-cart-table-form-submit-btn" type="submit" name="filter" value="<?php esc_html_e('Filter' , 'qof_form_order'); ?>">
					</div>
					
							<?php
						}
						if ( $category_flag || $tag_flag || $product_flag || $sku_flag ) {
							?>
					<div class="qof_top_filters_align_left_button"><input  type="submit"  class="qof-above-cart-table-form-submit-btn" value="<?php esc_html_e('Clear' , 'qof_form_order'); ?>" id="cat_tag_remove" ></input>
					</div>
							<?php
						}
						?>
				</div>
				<div class="qof_search_and_filter_right">
					<?php
					if ( $product_flag ) {
						?>
					<div class="qof_top_filters_align_right">
						<select class="qof_front_product_select" name="qof_front_product_select[]" 
						multiple data-placeholder="<?php esc_html_e('Select Product...' , 'qof_form_order'); ?>">
						<?php
						if ( isset( $_POST['qof_front_product_select'] ) ) {
							$qof_print_select_product = sanitize_meta( '', wp_unslash( $_POST['qof_front_product_select'] ), '' );

							foreach ( (array) $qof_print_select_product as $value ) {
								if ( $value ) {
									$product = wc_get_product( $value );
									?>
								<option value="<?php echo esc_attr( $value ); ?>" selected>
									<?php /* translators: %s: Customer billing full name */ ?>
									<?php echo esc_html__($product->get_name(), 'qof_form_order' ); ?></option>
									<?php
								}
							}
						}
						?>
					</select>
					</div>
						<?php
					}
					if ( $sku_flag ) {
						?>
					<div class="qof_top_filters_align_right">
						<select  class="qof_front_sku_select " name="qof_front_sku_select[]" multiple  data-placeholder="<?php esc_html_e('Select SKU...' , 'qof_form_order'); ?>">
						<?php
						if ( isset( $_POST['qof_front_sku_select'] ) ) {
							$qof_print_select_sku = sanitize_meta( '', wp_unslash( $_POST['qof_front_sku_select'] ), '' );
							foreach ( (array) $qof_print_select_sku as $value ) {
								if ( $value ) {
									$product = wc_get_product( $value );
									?>
								<option value="<?php echo esc_attr( $value ); ?>" selected>
									<?php /* translators: %s: Customer billing full name */ ?>
									<?php echo esc_attr($product->get_sku()); ?></option>
									<?php
								}
							}
						}
						?>
						</select>	
					</div>
						<?php
					}
					if ( $product_flag || $sku_flag ) {
						?>
					<div class="qof_top_filters_align_left_button">
						<input class="qof_search_btn qof-above-cart-table-form-submit-btn" type="submit" name="submit" value="<?php esc_html_e('Search' , 'qof_form_order'); ?>">
					</div>
						<?php
					}
					?>
				</div>
		</div>
</form>
<div class="qof_form_data">
		<?php
		include QOF_PLUGIN_DIR . 'class-addify-qof-update-table.php';
		?>
<div class="qof_no_page_button">
		<ul>
		<?php
		if ( $flag6 ) {
			include QOF_PLUGIN_DIR . 'class-addify-qof-product.php';
		}
		?>

		<?php
		if ( 'yes' === $qof_show_bottom_bulk ) {
			?>
		<li class="qof_bottom_align">
		<button class="qof-above-cart-table-form-bulk-btn simple-add-to-cart alt" type="button"><?php esc_html_e('Bulk Add to Cart', 'qof_form_order'); ?></button>
		</li>
		</ul>
			<?php
		}
		?>
</div>

<div class="qof_pagination_css">

		<li class="qof_replace_pagination qof_bottom_align ">
			<?php
			include QOF_PLUGIN_DIR . 'class-addify-qof-pagination.php';
			?>
		</li>
	</div>	
</div>	
	
		<?php
	}
}



/**
* Class Object.
*/
if ( class_exists( 'Addify_Qof_Frontend' ) ) {
		$addify_qof_frontend = new addify_qof_frontend();
}

